const getContractFactory = require("./deploy");

async function main() {
  let appContract = await getContractFactory("CloudApplication");
  // await addNodeNetworkInfo(appContract);
  // await getNodeNetworkInfo(appContract);
  await getAppInfo(appContract);
}

async function getNodeNetworkInfo(appContract) {
  let nodeId = "111";
  let res = await appContract.getNodeNetwork(nodeId);
  console.log("res:", res);
}

async function getAppInfo(appContract) {
  let appId = "0xAA28Df7fe41320432fa4efC2798B3CaF9300A218_4_1577243657_0";
  let res = await appContract.getAppInfo(appId);
  console.log("res:", res);
}

async function addNodeNetworkInfo(appContract) {
  let nodeId = "111";
  let res = await appContract.addNodeNetworkInfo(nodeId, "222", "3333", ["111", "222"], ["333", "444"], ["22", "44"], ["33", "55"], "0000");
  await res.wait();
  console.log("add success");
}

main().catch((error) => {
  console.error(error);
  process.exitCode = 1;
});