const hre = require("hardhat");

let isDeploy = false;

let contractName = [
  "CloudConstant",
  // "CloudGateway",
  // "CloudScheduler",
  "CloudVm",
  "CloudVmTask",
  // "CloudHost",
  "CloudApplication"
];

let contractAddress = [
  "0x7cd6941Af75A7D1575038d69F56175b4204eaeC6",
  // "0x993C630B94E4FfC2e9Cd39F9B5D65cE8c0B5B425",
  // "0x06425aa6a39E7eB09fC1E12C9653A1efA80ba46d",
  "0x72d036c860D66EA0e741Acd5569099C264bE5616",
  "0xd5271d2e46d5704587329FbfaB73E0290E64532A",
  // "0xF465eD8D34653Dc984d47c7Bb91890e7cDfCB297"
  "0x47ee3dAEE376836b38960dA1068aC4ffEf04f6DA"
];

async function deployConst() {

  let constContract = await hre.ethers.getContractFactory("CloudConstant");

  let constDeploy = await constContract.deploy();

  await constDeploy.deployed();

  console.log("deploy CloudConstant contract address:", constDeploy.address);

  return constDeploy.address;
}

async function deployOtherContract(constContract, contractName) {
  for (let i = 1; i < contractName.length; i++) {
    let name = contractName[i];
    let contract = await hre.ethers.getContractFactory(name);
    let deplyContract = await contract.deploy(constContract);
    await deplyContract.deployed();
    console.log("deploy " + name + " contract address ", deplyContract.address);
  }
}


async function getContractFactory(param) {
  for (let i = 0; i < contractName.length; i++) {
    let name = contractName[i];
    if (name == param) {
      let contract = await hre.ethers.getContractAt(param, contractAddress[i]);
      return contract;
    }
  }
}

async function main() {
  if (isDeploy) {
    let constAddress = await deployConst();
    await deployOtherContract(constAddress, contractName);
  }
}

async function getTranRes(txHash) {
  let txRes = await hre.ethers.provider.getTransaction(txHash);
  await txRes.wait();
  console.log("txRes:", txRes);
}

main().catch((error) => {
  console.error(error);
  process.exitCode = 1;
});

module.exports = getContractFactory